; Tiny Sierpinsky Triangle Generator v96.7.15.10a
; (like my version system?)
; Copyright (c) 1996, Justin Frankel
; Additional size optimizations by Kevin Vigor
; XCHG tip thanks to Richard Pavlicek (1 byte saved)
; 
; optimized for size - should assemble to a 55 byte .COM file
;
; Must be assembled with NASM.
; slightly updated 2002 for NASM. -JF

VID_MODE EQU 12h
SCR_WIDTH EQU 640
SCR_HEIGHT EQU 480

[org 100h]
[segment .text]

	mov al, VID_MODE
	int 10h
	mov bl, 21
	mov di, 3
BigLoop:
	mul bx
	inc ax
	push ax
	sub dx, dx
	div di
	dec dx
	jz short L1
	jns short L2
	sub cx, SCR_WIDTH/2
	add si, SCR_HEIGHT
L1:
	add cx, SCR_WIDTH
L2:
	shr cx, 1
	shr si, 1

	mov ah, 0Ch
	mov dx, si
	int 10h

	mov ah, 1
	int 16h
	pop ax
	jz short BigLoop

	xchg ax, di
	int 10h
	ret
END


